<?php
defined('BASEPATH') OR exit('No direct script access allowed');
require_once ('SuperCtrl.php');
ini_set('memory_limit', '-1');

class MobileAPI extends SuperCtrl {

    public function __construct() {
        parent::__construct();
        $this->load->model('model_mobileapi');
    }

    public function checkConnection() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['code'])) {
                $response["success"] = 1;
                $response["message"] = "Connection Ready !!";
                echo json_encode($response);
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function userLogin() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["username"]) and isset($_POST["password"]) and $userInfo = $this->model_mobileapi->varifyAppUser($_POST["username"], $_POST["password"])) {
                $response["products"] = array();
                if ($userInfo["Success"] == 1) {
                    $product = array();
                    $product["Name"] = $userInfo["Name"];
                    $product["Code"] = $userInfo["Code"];
                    $product["cnt"] = $userInfo["cnt"];
                    $product["Success"] = $userInfo["Success"];
                    $product["BillNo"] = $userInfo["BillNo"];
                    $product["NewBillNo"] = $userInfo["NewBillNo"];
                    array_push($response["products"], $product);
                    $response["success"] = 1;
                    echo json_encode($response);
                } else {
                    $product["cnt"] = $userInfo["cnt"];
                    $product["Success"] = $userInfo["Success"];
                    $response["success"] = 0;
                    echo json_encode($response);
                }
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }


    public function userLoginJewellery() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["username"]) and isset($_POST["password"])) {
                $pass=$_POST["password"];
                $userInfo = $this->model_mobileapi->JewelleryLogin($_POST["username"]);
               // print_r("$pass"."  $userInfo");
                if($userInfo==$pass){
                    $response["success"] = 1;
                    $response["message"] = "Password Matched";
                    echo json_encode($response);
                }else{
                 $response["success"] = 0;
                $response["message"] = "Incorrect Password..";
                $response["pass"] = $pass;
                $response["userInfo "] =  $userInfo ;
                echo json_encode($response);
                }
               
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }


    public function getParty() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['code']) or 1 == 1) {
                $username = $_POST['username'];
                $users = $this->model_mobileapi->getPartyWithBalance();

              //
             //   print_r($users);
                if ($users != false) {
                    $no_of_users = count($users);
                } else {
                    $no_of_users = 0;
                }
                if ($no_of_users > 0) {
                    $response["products"] = array();
                    foreach ($users as $key => $row) {
                        $product = array();
                        $product["name"] = $row["Name"];
                        $product["code"] = $row["Code"];
                        $product["balance"] = $row["Opening"];
                        $product["mobileno"] = $row["Ph"];
                        $product["cst_no"] = $row["CstNo"];
                        $product["gst_no"] = $row["TinNo"];
                        $product["party_type"] = $row["party_type"];
                        $product["address1"] = $row["Address1"];
                        $product["address2"] = $row["Address2"];
                        $product["emp"] = $row["emp"];
                        $product["outlet"] = $row["outlet"];
                        array_push($response["products"], $product);
                    }
                    $response["success"] = 1;
                    echo json_encode($response);
                } else {
                    $response["success"] = 0;
                    $response["message"] = "No party found";
                    echo json_encode($response);
                }
            } else {
                $response["success"] = 0;
                $response["message"] = "No party found";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }



    public function getPurchase() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['code']) or 1 == 1) {
                $username = $_POST['username'];
              //  $users = $this->model_mobileapi->getPurchaseFortakeStock($username);

                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->getPurchaseFortakeStock($username);
                echo json_encode($data);
               
            } else {
                $response["success"] = 0;
                $response["message"] = "No party found";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }




    public function getProducts() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['code']) or 1 == 1) {
                $username = $_POST['username'];
                $users = $this->model_mobileapi->getProducts();
                $users1 = $this->model_mobileapi->getGodownStock($username);
                if ($users != false) {
                    $no_of_users = count($users);
                } else {
                    $no_of_users = 0;
                }
                if ($users1 != false) {
                    $no_of_users1 = count($users1);
                } else {
                    $no_of_users1 = 0;
                }
                if ($no_of_users > 0) {
                    $response["products"] = array();
                    for ($i = 0; $i < count($users); $i++) {
                        $product = array();
                        $product["itemname"] = $users[$i]["ItemNameTextField"];
                        $product["itemcode"] = $users[$i]["ItemC"];
                        $product["Cost"] = $users[$i]["Cost"];
                        $product["SecCostRate"] = $users[$i]["SecCostRate"];
                        $product["stock"] = $users[$i]["curr_stock"];
                        $product["base_rate"] = $users[$i]["Rate1"];
                        $product["sec_rate"] = $users[$i]["SecRetailRate"];
                        $product["base_unit"] = $users[$i]["Typ"];
                        $product["sec_unit"] = $users[$i]["SecUnit"];
                        $product["category"] = $users[$i]["Size"];
                        $product["tax"] = $users[$i]["Tax1"];
                        $product["img"] = "noimage";
                        $product["base_rate_retail"] = $users[$i]["Rate1"];
                        $product["base_rate_wholesale"] = $users[$i]["Rate2"];
                        $product["sec_rate_retail"] = $users[$i]["SecRetailRate"];
                        $product["sec_rate_wholesale"] = $users[$i]["SecRate2"];
                        $product["RatePerInch"] = $users[$i]["RatePerInch"];
                        $product["qty_in_pack"] = $users[$i]["Pack"];
                        $product["Company"] = $users[$i]["Company"];
                        $product["ArabicName"] = $users[$i]["ArabicName"];
                        $product["ThirdUnit"] = $users[$i]["ThirdUnit"];
                        $product["ThirdCost"] = $users[$i]["ThirdCost"];
                        $product["ThirdRate1"] = $users[$i]["ThirdRate1"];
                        $product["ThirdRate2"] = $users[$i]["ThirdRate2"];
                        $product["ThirdPack"] = $users[$i]["ThirdPack"];
                        $product["newitemcode"] = $users[$i]["NewItemCode"];
                        $product["secbarcode"] = $users[$i]["SecBarcode"];
                        $product["thirdbarcode"] = $users[$i]["ThirdBarcode"];
                        $product["CostRs"] = $users[$i]["CostRs"];
                        
                        array_push($response["products"], $product);
                    }
                    if ($no_of_users1 > 0) {
                        $response["godown"] = array();
                        for ($j = 0; $j < count($users1); $j++) {
                            $product1 = array();
                            $product1["itemname"] = $users1[$j]["Item"];
                            $product1["stock"] = $users1[$j]["qty"];
                            $product1["godown"] = $users1[$j]["godown"];
                            $product1["cst"] = $users1[$j]["cst"];
                            $product1["it_unit"] = $users1[$j]["it_unit"];
                            $product1["it_pack"] = $users1[$j]["it_pack"];
                            array_push($response["godown"], $product1);
                            $response["success_godown"] = 1;
                        }
                    } else {
                        $response["success_godown"] = 0;
                    }
                    $response["success"] = 1;
                    echo json_encode($response);
                } else {
                    $response["success"] = 0;
                    $response["message"] = "No Products found";
                    echo json_encode($response);
                }
            } else {
                $response["success"] = "0";
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = "0";
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function getPrevilage() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["username"])) {
                $users = $this->model_mobileapi->getUserPrevilage($_POST['username']);
                if ($users != false) {
                    $no_of_users = count($users);
                } else {
                    $no_of_users = 0;
                }
                if ($no_of_users > 0) {
                    $response["privilage"] = array();
                    for ($i = 0; $i < count($users); $i++) {
                        $privilage = array();
                        $privilage["sales"] = $users[$i]["sales"];
                        $privilage["purchase"] = $users[$i]["purchase"];
                        $privilage["sales_ret"] = $users[$i]["sales_ret"];
                        $privilage["purch_ret"] = $users[$i]["purch_ret"];
                        $privilage["salesitem"] = $users[$i]["salesitem"];
                        $privilage["ledger"] = $users[$i]["ledger"];
                        $privilage["warehouse"] = $users[$i]["warehouse"];
                        $privilage["waretrans"] = $users[$i]["waretrans"];
                        $privilage["reports"] = $users[$i]["reports"];
                        $privilage["receipt"] = $users[$i]["receipt"];
                        $privilage["reports_sec"] = $users[$i]["reports_sec"];
                        array_push($response["privilage"], $privilage);
                    }
                    $response["success"] = 1;
                    echo json_encode($response);
                } else {
                    $response["success"] = 0;
                    $response["message"] = "No Privilage found";
                    echo json_encode($response);
                }
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }


    public function getMaxValue(){
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["username"])) {
                $users = $this->model_mobileapi->getUserPrevilage($_POST['username']);
                if ($users != false) {
                    $no_of_users = count($users);
                } else {
                    $no_of_users = 0;
                }
                if ($no_of_users > 0) {
                    $response["privilage"] = array();
                    for ($i = 0; $i < count($users); $i++) {
                        $privilage = array();
                        $privilage["sales"] = $users[$i]["sales"];
                        $privilage["purchase"] = $users[$i]["purchase"];
                        $privilage["sales_ret"] = $users[$i]["sales_ret"];
                        $privilage["purch_ret"] = $users[$i]["purch_ret"];
                        $privilage["salesitem"] = $users[$i]["salesitem"];
                        $privilage["ledger"] = $users[$i]["ledger"];
                        $privilage["warehouse"] = $users[$i]["warehouse"];
                        $privilage["waretrans"] = $users[$i]["waretrans"];
                        $privilage["reports"] = $users[$i]["reports"];
                        $privilage["receipt"] = $users[$i]["receipt"];
                        $privilage["reports_sec"] = $users[$i]["reports_sec"];
                        array_push($response["privilage"], $privilage);
                    }
                    $response["success"] = 1;
                    echo json_encode($response);
                } else {
                    $response["success"] = 0;
                    $response["message"] = "No Privilage found";
                    echo json_encode($response);
                }
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function getEmployeeName() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['code'])) {
                $users = $this->model_mobileapi->getEmployeeName();
                if ($users != false) {
                    $no_of_users = count($users);
                } else {
                    $no_of_users = 0;
                }
                if ($no_of_users > 0) {
                    $response["products"] = array();
                    for ($i = 0; $i < count($users); $i++) {
                        $product = array();
                        $product["empName"] = $users[$i]["Name"];
                        array_push($response["products"], $product);
                    }
                    $response["success"] = 1;
                    echo json_encode($response);
                } else {
                    $response["success"] = 0;
                    $response["message"] = "No data found";
                    echo json_encode($response);
                }
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function getEmployeeLocationStatus() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['code']) and isset($_POST['date1']) and isset($_POST['date2']) and isset($_POST['employeeName'])) {
                $date1 = $_POST['date1'];
                $date2 = $_POST['date2'];
                $employeeName = $_POST['employeeName'];
                $users = $this->model_mobileapi->getLocatioInfo($date1, $date2, $employeeName);
                if ($users != false) {
                    $no_of_users = count($users);
                } else {
                    $no_of_users = 0;
                }
                if ($no_of_users > 0) {
                    $response["products"] = array();
                    for ($i = 0; $i < count($users); $i++) {
                        $product = array();
                        $product["latitude"] = $users[$i]["latitude"];
                        $product["longitude"] = $users[$i]["longitude"];
                        array_push($response["products"], $product);
                    }
                    $response["success"] = 1;
                    echo json_encode($response);
                } else {
                    $response["success"] = 0;
                    $response["message"] = "No party found";
                    echo json_encode($response);
                }
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function getReports() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            $reportType = isset($_POST["reportType"]) ? $_POST["reportType"] : "";
            $empName = isset($_POST["empName"]) ? $_POST["empName"] : "";
            $partyName = isset($_POST["partyName"]) ? $_POST["partyName"] : "";
            $date1 = isset($_POST["date1"]) ? $_POST["date1"] : "";
            $date2 = isset($_POST["date2"]) ? $_POST["date2"] : "";
            $billNumber = isset($_POST["billNo"]) ? $_POST["billNo"] : "";
            $itemName = isset($_POST["itemName"]) ? $_POST["itemName"] : "";
            $barcode = isset($_POST["brcode"]) ? $_POST["brcode"] : "";
            $barcode2 = isset($_POST["datas"]) ? $_POST["datas"] : "";
            $br =json_decode($barcode2);

            $data = array();
            $data["response"] = array();
            if ($reportType === "employeeWiseSalesReportEdit") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->employeeWiseSalesReportEdit($billNumber);
                echo json_encode($data);
            } else if ($reportType === "employeeWiseSalesReportEditMaster") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->employeeWiseSalesReportEditMaster($billNumber);
                echo json_encode($data);
            }else if ($reportType === "updateDebitReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->updateDebitReport($billNumber);
                echo json_encode($data);
            }else if ($reportType === "employeeWiseSalesReportEditCollection") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->employeeWiseSalesReportEditCollection($billNumber);
                echo json_encode($data);
            }else if ($reportType === "employeeWiseSalesReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->employeeWiseSalesReport($date1, $date2, $empName);
                echo json_encode($data);
            } else if ($reportType === "collectionReportEmployeeWise") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->collectionReportEmployeeWise($date1, $date2, $empName);
                echo json_encode($data);
            } else if ($reportType === "collectionReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->collectionReport($date1, $date2);
                echo json_encode($data);
            }else if ($reportType === "expenseReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->expenseReport($date1, $date2);
                echo json_encode($data);
            }else if ($reportType === "paymentReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->paymentReport($date1, $date2);
                echo json_encode($data);
            } else if ($reportType === "openingReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->openingReport($date1);
                echo json_encode($data);
            } else if ($reportType === "cashBookReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->cashBookReport($date1, $date2);
                echo json_encode($data);
            } else if ($reportType === "purchaseReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->purchaseReport($date1, $date2);
                echo json_encode($data);
            } else if ($reportType === "salesReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->salesReport($date1, $date2);
                echo json_encode($data);
            } else if ($reportType === "orderReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->orderReport($date1, $date2);
                echo json_encode($data);
            } else if ($reportType === "ledger") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->ledger($date1, $date2, $partyName);
                echo json_encode($data);
            } else if ($reportType === "currentStockReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->currentStockReport($_POST["empName"]);
                echo json_encode($data);
            } else if ($reportType === "currentStockReportEMPWise") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->currentStockReportEMPWise($_POST["empName"]);
                echo json_encode($data);
            }else if($reportType === "currentStockReportSalesItem"){
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->currentStockReportSalesItem($_POST["empName"]);
                echo json_encode($data);
             } else if ($reportType === "salesReportBillNoWise") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->getSalesDetailsForBillno($billNumber);
                echo json_encode($data);
            } else if ($reportType === "itemwiseSalesReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->getItemWiseSalesReport($date1, $date2);
                echo json_encode($data);
            }else if ($reportType === "CashBookData") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->CashBookData($empName,$date1,$date2);
                echo json_encode($data);
            }else if ($reportType === "CashBookDataOpening") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->CashBookDataOpening($empName,$date1,$date2);
                echo json_encode($data);
            } else if ($reportType === "orderReportEMPWise") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->employeeWiseorderReport($date1, $date2, $empName);
                echo json_encode($data);
            } else if ($reportType === "auditingReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->employeeWiseAuditingReport($empName);
                echo json_encode($data);
            } else if ($reportType === "intransReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->intransReport($date1, $date2);
                echo json_encode($data);
            }else if ($reportType === "employeeWiseSalesReportBtoc") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->employeeWiseSalesReportBtoc($date1, $date2, $empName);
                echo json_encode($data);
            }else if ($reportType === "intransReportEdit") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->intransReportEdit($billNumber,$partyName);
                echo json_encode($data);
            }else if ($reportType === "intransLedgerReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->intransLedgerReport($date1, $date2, $partyName);
                echo json_encode($data);
            }else if ($reportType === "cashparty") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->getCashparty();
                echo json_encode($data);
            }else if ($reportType === "SalesManWiseReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->SaleMansReport($date1, $date2, $empName);
                echo json_encode($data);
            }else if ($reportType === "EnquiryReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->EnquiryReport($date1, $date2, $empName);
                echo json_encode($data);
            }else if ($reportType === "getBarcodeStock") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->getBarcodeStock($barcode, $empName);
                echo json_encode($data);
            }else if ($reportType === "getTakeStockData") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->getBarcodeStockForTakeStock($barcode2);
               // $data["success2"] = $barcode2;
                echo json_encode($data);
            }else if ($reportType === "getEnquiryDescription") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->getEnquiryDescription($itemName, $billNumber);
                echo json_encode($data);
            }else if ($reportType === "getBarcode") {
               if($data["response"] = $this->model_mobileapi->getPurchaseBarcode($barcode)){
                $data["success"] = 1;
                $data["message"] = 1;
                echo json_encode($data);
               }else if($data["response"] = $this->model_mobileapi->getBaseBarcode($barcode)){
                $data["success"] = 1;
                $data["message"] = 2;
                echo json_encode($data);
               }else if($data["response"] = $this->model_mobileapi->getSecBarcode($barcode)){
                $data["success"] = 1;
                $data["message"] = 3;
                echo json_encode($data);
               }else if($data["response"] = $this->model_mobileapi->getThirdBarcode($barcode)){
                $data["success"] = 1;
                $data["message"] = 4;
                echo json_encode($data);
            }else if ($reportType === "getBarcode") {
                if ($data["response"] = $this->model_mobileapi->getPurchaseBarcode($barcode)) {
                    $data["success"] = 1;
                    $data["message"] = 1;
                    echo json_encode($data);
                } else if ($data["response"] = $this->model_mobileapi->getBaseBarcode($barcode)) {
                    $data["success"] = 1;
                    $data["message"] = 2;
                    echo json_encode($data);
                } else if ($data["response"] = $this->model_mobileapi->getSecBarcode($barcode)) {
                    $data["success"] = 1;
                    $data["message"] = 3;
                    echo json_encode($data);
                } else if ($data["response"] = $this->model_mobileapi->getThirdBarcode($barcode)) {
                    $data["success"] = 1;
                    $data["message"] = 4;
                    echo json_encode($data);
                } else {
                    $data["success"] = 0;
                    $data["message"] = "no Barcode found";
                    echo json_encode($data);
                }
            }else{
                $data["success"] = 0;
                $data["message"] = "no Barcode found";
                echo json_encode($data);
            }
            }else if ($reportType === "getSalesReturnReport") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->salesReturnReport($date1, $date2,$empName);
                echo json_encode($data);
            }else if ($reportType === "salesreturntoedit") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->employeeWiseSalesReturnEdit($billNumber);
                echo json_encode($data);
            }else if ($reportType === "employeeWiseSalesReportEditSRMasterdetails") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->employeeWiseSalesReturnEditMaster($billNumber);
                echo json_encode($data);
            }else if ($reportType === "employeeWiseSalesReturnEditCollection") {
                $data["success"] = 1;
                $data["response"] = $this->model_mobileapi->employeeWiseSalesReturnEditCollection($billNumber);
                echo json_encode($data);
            }else{
                $response["success"] = $reportType;
                $response["message"] = "No value found";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }


public function SaveEnquiry(){
    if ($_SERVER['REQUEST_METHOD'] === 'POST') {
        if (isset($_POST['code']) and isset($_POST["enquiry_data"])) {
          $EnquiryData=$_POST["enquiry_data"];
            $data = json_decode($EnquiryData, true);
            $a = array();
            $b = array();
         //   $data = $_POST["enquiry_data"];

           // print_r($data);
           $billNo = $this->model_mobileapi->getEnqNo();

            for ($i = 0; $i <count($data); $i++) {// count($data)
                // $bin = base64_decode($data[$i]["image"]);
                // $im = imageCreateFromString($bin);
             //   $a = $data[$i]["image"];
              //  $im=$this->base64_to_jpeg($a,"PNG");

             // print_r($a);
            //   list($type, $datas) = explode(';', $a);
            //   list(, $datas)      = explode(',', $datas);
            //   print_r($datas);
           //   $datas = base64_decode($a);
            //  print_r($datas);


//               $imageData = base64_decode($a);
// $source = imagecreatefromstring($imageData);
             //   print_r($source);
                // print_r('here '.$im);
              //  $SliderimgData=$this->do_image_upload($datas,"gif|jpg|png|jpeg");
               // print_r($SliderimgData);
             //   $imagePath = $SliderimgData["path"];
                // print_r($imagePath);

                    $res = $this->model_mobileapi->storeEnquiry($billNo, $data[$i]["product"], $data[$i]["enq_date"], $data[$i]["description"], $data[$i]["image"],$data[$i]["diamondwt"],$data[$i]["grosswt"],$data[$i]["qty"],$data[$i]["counter_name"]);
                    if ($res) {
                       

                      //  $count++;
                     //   $b["bill_no"] = $billNo;
                        $b["success"] = '1';
                        // $b["status"] = 'uploaded';
                        // $b["previlage"] = '1';
                       // $b["count"] = $cnt;
                        array_push($a, $b);
                    } else {
                      //  $b["bill_no"] = $billNo;
                      $b["success"] = '0';
                        // $b["status"] = 'pending';
                        // $b["previlage"] = '1';
                   //     $b["count"] = $cnt;
                        array_push($a, $b);
                    }
                    echo json_encode($a);
                
            }


        }else{
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response); 
        }

    } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
}



public function do_image_upload($fileInputFieldName, $type)
    { //$type gif|jpg|png
        $uploadfolder = date("Y-m");
        $uploadpath = 'jr_files' . DIRECTORY_SEPARATOR;
        if (!is_dir($uploadpath . $uploadfolder)) {
            // creating month-year folder to upload item  image 
            mkdir($uploadpath . $uploadfolder, 0777, TRUE);
        }
        $fullPath = $uploadpath . DIRECTORY_SEPARATOR . $uploadfolder;

        $config['upload_path'] = $fullPath;
        $config['allowed_types'] = $type;
        $config['max_size'] = 5024;
        $config['max_width'] = 5024;
        $config['max_height'] = 5024;
        $config['overwrite'] = TRUE;
        $this->load->library('upload', $config);

        if (!$this->upload->do_upload($fileInputFieldName)) {
            $error = array('error' => $this->upload->display_errors());
            //            $this->load->view('upload_form', $error);
            print_r($error);
            return 0;
        } else {
            $data = array('upload_data' => $this->upload->data());
            $fileDetails['path'] = DIRECTORY_SEPARATOR . "jr_files" . DIRECTORY_SEPARATOR . $uploadfolder . DIRECTORY_SEPARATOR . $data['upload_data']['file_name'];
            $fileDetails['extension'] = $file_ext = pathinfo($fileDetails['path'], PATHINFO_EXTENSION);
            return $fileDetails;
        }
    }

function base64_to_jpeg($base64_string, $output_file) {
    // open the output file for writing
    $ifp = fopen( $output_file, 'wb' ); 

    // split the string on commas
    // $data[ 0 ] == "data:image/png;base64"
    // $data[ 1 ] == <actual base64 string>
    $data = explode( ',', $base64_string );

    // we could add validation here with ensuring count( $data ) > 1
    fwrite( $ifp, base64_decode( $data[ 1 ] ) );

    // clean up the file resource
    fclose( $ifp ); 

    return $output_file; 
}

    public function saveInvoice() {//saveInvoice
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['code']) and isset($_POST["salesBillItems"]) and isset($_POST["salesBillMasterDetails"])) {
                $salesBillItemsData = $_POST["salesBillItems"];
                $masterDetailsData = $_POST["salesBillMasterDetails"];
            //    if (get_magic_quotes_gpc()) {
            //        $salesBillItemsData = stripslashes($salesBillItemsData);
            //        $masterDetailsData = stripslashes($masterDetailsData);
            //    }
                  
                $data = json_decode($salesBillItemsData, true);
                $masterDetails = json_decode($masterDetailsData, true);
                $cnt=0;
                if ($_POST['code'] == 1) {
                    $previlage = $this->model_mobileapi->getSynPrevilage($_POST['user']);
                    if ($previlage == 1) {
                        $a = array();
                        $b = array();
                        $count = 0;
                        for ($z = 0; $z < count($masterDetails); $z++) {
                            $cnt++;
                            $billNo = $this->model_mobileapi->getBillNo();
                            $masterDetails[$z]["BillNo"] = $billNo;
                            $this->model_mobileapi->deleteFromMasterDetailsByBillNo($masterDetails[$z]["local_app_user_entry_id"], $billNo);
                            $this->model_mobileapi->getQuery("MasterDetails", $masterDetails[$z]);
                            for ($i = 0; $i < count($data); $i++) {
                                if ($data[$i]["local_app_user_entry_id"] != $masterDetails[$z]["local_app_user_entry_id"]) {
                                    continue;
                                } else {
                                    $res = $this->model_mobileapi->storeUser($data[$i]["itemname"], $data[$i]["price"], $data[$i]["qty"], $data[$i]["unit"], $data[$i]["party"], $data[$i]["godown"], $data[$i]["employee"], $data[$i]["date1"], $data[$i]["invno"], $data[$i]["local_app_user_entry_id"], $billNo, $data[$i]["serial_no"], $data[$i]["taxAmount"], $data[$i]["taxPercentage"], $data[$i]["itemcode"], $data[$i]["qty_in_pack"], $data[$i]["cost"], $data[$i]["disc"], $data[$i]["sqft"], $data[$i]["taxtype"]);
                                    if ($res) {
                                        $count++;
                                        $b["bill_no"] = $billNo;
                                        $b["id"] = $data[$i]["local_app_user_entry_id"];
                                        $b["status"] = 'uploaded';
                                        $b["previlage"] = '1';
                                        $b["count"] = $cnt;
                                        array_push($a, $b);
                                    } else {
                                        $b["bill_no"] = $billNo;
                                        $b["id"] = $data[$i]["local_app_user_entry_id"];
                                        $b["status"] = 'pending';
                                        $b["previlage"] = '1';
                                        $b["count"] = $cnt;
                                        array_push($a, $b);
                                    }
                                }
                            }
                        }
                        $this->model_mobileapi->updateSyncActivationStatus($_POST['user']);
                    } else {
                        $a = array();
                        $b = array();
                        $b["bill_no"] = '0';
                        $b["id"] = '0';
                        $b["status"] = 'Update user sync sales bill Privilage !!';
                        $b["previlage"] = '-1';
                        array_push($a, $b);
                    }
                    echo json_encode($a);
                } else {
                    $a = array();
                    $b = array();
                    for ($z = 0; $z < count($masterDetails); $z++) {
                        $cnt++;
                        $billNo = $this->model_mobileapi->getBillNo();
                        $masterDetails[$z]["BillNo"] = $billNo;
                        $this->model_mobileapi->deleteFromMasterDetailsByBillNo($masterDetails[$z]["local_app_user_entry_id"], $billNo);
                         $this->model_mobileapi->getQuery("MasterDetails", $masterDetails[$z]);
                        // $cnt =  $this->model_mobileapi->getQuerymasterdetails("MasterDetails", $masterDetails[$z]);
                        for ($i = 0; $i < count($data); $i++) {
                            if ($data[$i]["local_app_user_entry_id"] != $masterDetails[$z]["local_app_user_entry_id"]) {
                                continue;

                            } else {
                                $res = $this->model_mobileapi->storeUser($data[$i]["itemname"], $data[$i]["price"], $data[$i]["qty"], $data[$i]["unit"], $data[$i]["party"], $data[$i]["godown"], $data[$i]["employee"], $data[$i]["date1"], $data[$i]["invno"], $data[$i]["local_app_user_entry_id"], $billNo, $data[$i]["serial_no"], $data[$i]["taxAmount"], $data[$i]["taxPercentage"], $data[$i]["itemcode"], $data[$i]["qty_in_pack"], $data[$i]["cost"], $data[$i]["disc"], $data[$i]["sqft"],$data[$i]["taxtype"]);
                                if ($res) {
                                    $b["bill_no"] = $billNo;
                                    $b["id"] = $data[$i]["local_app_user_entry_id"];
                                    $b["status"] = 'uploaded';
                                    $b["previlage"] = '1';
                                    $b["count"] = $cnt;
                                    array_push($a, $b);
                                } else {
                                    $b["bill_no"] = $billNo;
                                    $b["id"] = $data[$i]["local_app_user_entry_id"];
                                    $b["status"] = 'pending';
                                    $b["previlage"] = '1';
                                    $b["count"] = $cnt;
                                    array_push($a, $b);
                                }
                            }
                        }
                    }
                    echo json_encode($a);
                }
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function saveInvoice8b() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['code']) and isset($_POST["salesBillItems"]) and isset($_POST["salesBillMasterDetails"])) {
                $salesBillItemsData = $_POST["salesBillItems"];
                $masterDetailsData = $_POST["salesBillMasterDetails"];
            //    if (get_magic_quotes_gpc()) {
            //        $salesBillItemsData = stripslashes($salesBillItemsData);
            //        $masterDetailsData = stripslashes($masterDetailsData);
            //    }
                  
                $data = json_decode($salesBillItemsData, true);
                $masterDetails = json_decode($masterDetailsData, true);
                if ($_POST['code'] == 1) {
                    $previlage = $this->model_mobileapi->getSynPrevilage($_POST['user']);
                    if ($previlage == 1) {
                        $a = array();
                        $b = array();
                        for ($z = 0; $z < count($masterDetails); $z++) {
                            $billNo = $this->model_mobileapi->getBillNo8b();
                            $masterDetails[$z]["BillNo"] = $billNo;
                            $this->model_mobileapi->deleteFromMasterDetailsByBillNo($masterDetails[$z]["local_app_user_entry_id"], $billNo);
                            $this->model_mobileapi->getQuery("masterdetails8bnew", $masterDetails[$z]);
                            for ($i = 0; $i < count($data); $i++) {
                                if ($data[$i]["local_app_user_entry_id"] != $masterDetails[$z]["local_app_user_entry_id"]) {
                                    continue;
                                } else {
                                    $res = $this->model_mobileapi->storeUser8b($data[$i]["itemname"], $data[$i]["price"], $data[$i]["qty"], $data[$i]["unit"], $data[$i]["party"], $data[$i]["godown"], $data[$i]["employee"], $data[$i]["date1"], $data[$i]["invno"], $data[$i]["local_app_user_entry_id"], $billNo, $data[$i]["serial_no"], $data[$i]["taxAmount"], $data[$i]["taxPercentage"], $data[$i]["itemcode"], $data[$i]["qty_in_pack"], $data[$i]["cost"], $data[$i]["disc"], $data[$i]["sqft"]);
                                    if ($res) {
                                        $b["bill_no"] = $billNo;
                                        $b["id"] = $data[$i]["local_app_user_entry_id"];
                                        $b["status"] = 'uploaded';
                                        $b["previlage"] = '1';
                                        array_push($a, $b);
                                    } else {
                                        $b["bill_no"] = $billNo;
                                        $b["id"] = $data[$i]["local_app_user_entry_id"];
                                        $b["status"] = 'pending';
                                        $b["previlage"] = '1';
                                        array_push($a, $b);
                                    }
                                }
                            }
                        }
                        $this->model_mobileapi->updateSyncActivationStatus($_POST['user']);
                    } else {
                        $a = array();
                        $b = array();
                        $b["bill_no"] = '0';
                        $b["id"] = '0';
                        $b["status"] = 'Update user sync sales bill Privilage !!';
                        $b["previlage"] = '-1';
                        array_push($a, $b);
                    }
                    echo json_encode($a);
                } else {
                    $a = array();
                    $b = array();
                    for ($z = 0; $z < count($masterDetails); $z++) {
                        $billNo = $this->model_mobileapi->getBillNo8b();
                        $masterDetails[$z]["BillNo"] = $billNo;
                        $this->model_mobileapi->deleteFromMasterDetailsByBillNo($masterDetails[$z]["local_app_user_entry_id"], $billNo);
                        $this->model_mobileapi->getQuery("masterdetails8bnew", $masterDetails[$z]);
                        for ($i = 0; $i < count($data); $i++) {
                            if ($data[$i]["local_app_user_entry_id"] != $masterDetails[$z]["local_app_user_entry_id"]) {
                                continue;
                            } else {
                                $res = $this->model_mobileapi->storeUser8b($data[$i]["itemname"], $data[$i]["price"], $data[$i]["qty"], $data[$i]["unit"], $data[$i]["party"], $data[$i]["godown"], $data[$i]["employee"], $data[$i]["date1"], $data[$i]["invno"], $data[$i]["local_app_user_entry_id"], $billNo, $data[$i]["serial_no"], $data[$i]["taxAmount"], $data[$i]["taxPercentage"], $data[$i]["itemcode"], $data[$i]["qty_in_pack"], $data[$i]["cost"], $data[$i]["disc"], $data[$i]["sqft"]);
                                if ($res) {
                                    $b["bill_no"] = $billNo;
                                    $b["id"] = $data[$i]["local_app_user_entry_id"];
                                    $b["status"] = 'uploaded';
                                    $b["previlage"] = '1';
                                    array_push($a, $b);
                                } else {
                                    $b["bill_no"] = $billNo;
                                    $b["id"] = $data[$i]["local_app_user_entry_id"];
                                    $b["status"] = 'pending';
                                    $b["previlage"] = '1';
                                    array_push($a, $b);
                                }
                            }
                        }
                    }
                    echo json_encode($a);
                }
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function updateInvoice() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['code']) and isset($_POST["salesBillItems"]) and isset($_POST["salesBillMasterDetails"])) {
                $salesBillItemsData = $_POST["salesBillItems"];
                $masterDetailsData = $_POST["salesBillMasterDetails"];
            //    if (get_magic_quotes_gpc()) {
            //        $salesBillItemsData = stripslashes($salesBillItemsData);
            //        $masterDetailsData = stripslashes($masterDetailsData);
            //    }
                
            //     if((function_exists("get_magic_quotes_gpc") && get_magic_quotes_gpc())    || (ini_get('magic_quotes_sybase') && (strtolower(ini_get('magic_quotes_sybase'))!="off")) ){
            //         $salesBillItemsData = stripslashes($salesBillItemsData);
            //         $masterDetailsData = stripslashes($masterDetailsData);
            // }
                $data = json_decode($salesBillItemsData, true);
                $masterDetails = json_decode($masterDetailsData, true);
                if ($_POST['code'] == 1) {
                    $previlage = $this->model_mobileapi->getSynPrevilage($_POST['user']);
                    if ($previlage == 1) {
                        $a = array();
                        $b = array();
                        for ($z = 0; $z < count($masterDetails); $z++) {
                            for ($i = 0; $i < count($data); $i++) {
                                $inv_no = $data[$i]["invno"];
                                $emp = $data[$i]["employee"];
                            }
                            $billNo = $this->model_mobileapi->getUpdateBillNo($inv_no, $emp);
                            $this->model_mobileapi->deleteFromSalesBillByBillNo($inv_no, $emp);
                            $this->model_mobileapi->getUpdateQueryMasterDetails($billNo, $masterDetails[$z]["BillDate"], $masterDetails[$z]["BillPartyName"], $masterDetails[$z]["BillTotalField"], $masterDetails[$z]["BillDiscAmtField"], $masterDetails[$z]["BillDiscPercField"], $masterDetails[$z]["BillTaxField"], $masterDetails[$z]["BillPackageField"], $masterDetails[$z]["BillNetTotalField"], $masterDetails[$z]["BillTyp"], $masterDetails[$z]["BillTime"], $masterDetails[$z]["OrderNo"], $masterDetails[$z]["TDiscAmt"], $masterDetails[$z]["TaxAmt"], $masterDetails[$z]["TItTaxAmt"], $masterDetails[$z]["TAmt"], $masterDetails[$z]["Cess"], $emp, $masterDetails[$z]["DCNoTax"], $masterDetails[$z]["TotDiscPercAmt"], $masterDetails[$z]["CessP"], $masterDetails[$z]["TotItWiseQty1"], $masterDetails[$z]["CashP"], $masterDetails[$z]["CashCard"], $masterDetails[$z]["CashCardAmt"], $masterDetails[$z]["godown"], $masterDetails[$z]["del_date"], $masterDetails[$z]["local_app_user_entry_id"], $inv_no, $masterDetails[$z]["SystemId"]);
                            for ($i = 0; $i < count($data); $i++) {
                                if ($data[$i]["local_app_user_entry_id"] != $masterDetails[$z]["local_app_user_entry_id"]) {
                                    continue;
                                } else {
                                    $res = $this->model_mobileapi->storeUser($data[$i]["itemname"], $data[$i]["price"], $data[$i]["qty"], $data[$i]["unit"], $data[$i]["party"], $data[$i]["godown"], $data[$i]["employee"], $data[$i]["date1"], $data[$i]["invno"], $data[$i]["local_app_user_entry_id"], $billNo, $data[$i]["serial_no"], $data[$i]["taxAmount"], $data[$i]["taxPercentage"], $data[$i]["itemcode"], $data[$i]["qty_in_pack"], $data[$i]["cost"],$data[$i]["disc"],$data[$i]["sqft"],$data[$i]["taxtype"]);
                                    if ($res) {
                                        $b["bill_no"] = $billNo;
                                        $b["id"] = $data[$i]["local_app_user_entry_id"];
                                        $b["status"] = 'uploaded';
                                        $b["previlage"] = '1';
                                        array_push($a, $b);
                                    } else {
                                        $b["bill_no"] = $billNo;
                                        $b["id"] = $data[$i]["local_app_user_entry_id"];
                                        $b["status"] = 'pending';
                                        $b["previlage"] = '1';
                                        array_push($a, $b);
                                    }
                                }
                            }
                        }
                        echo json_encode($a);
                        $this->model_mobileapi->updateSyncActivationStatus($_POST['user']);
                    } else {
                        $a = array();
                        $b = array();
                        $b["bill_no"] = '0';
                        $b["id"] = '0';
                        $b["status"] = 'Update user sync sales bill Privilage !!';
                        $b["previlage"] = '-1';
                        array_push($a, $b);
                    }
                    echo json_encode($a);
                } else {
                    $a = array();
                    $b = array();
                    for ($z = 0; $z < count($masterDetails); $z++) {
                        for ($i = 0; $i < count($data); $i++) {
                            $inv_no = $data[$i]["invno"];
                            $emp = $data[$i]["employee"];
                        }
                        $billNo = $this->model_mobileapi->getUpdateBillNoNew($inv_no, $emp);
                        $this->model_mobileapi->deleteFromSalesBillByBillNo($inv_no, $emp);
                        $this->model_mobileapi->getUpdateQueryMasterDetailsNew($billNo, $masterDetails[$z]["BillDate"], $masterDetails[$z]["BillPartyName"], $masterDetails[$z]["BillTotalField"], $masterDetails[$z]["BillDiscAmtField"], $masterDetails[$z]["BillDiscPercField"], $masterDetails[$z]["BillTaxField"], $masterDetails[$z]["BillPackageField"], $masterDetails[$z]["BillNetTotalField"], $masterDetails[$z]["BillTyp"], $masterDetails[$z]["BillTime"], $masterDetails[$z]["OrderNo"], $masterDetails[$z]["TDiscAmt"], $masterDetails[$z]["TaxAmt"], $masterDetails[$z]["TItTaxAmt"], $masterDetails[$z]["TAmt"], $masterDetails[$z]["Cess"], $emp, $masterDetails[$z]["DCNoTax"], $masterDetails[$z]["TotDiscPercAmt"], $masterDetails[$z]["CessP"], $masterDetails[$z]["TotItWiseQty1"], $masterDetails[$z]["CashP"], $masterDetails[$z]["CashCard"], $masterDetails[$z]["CashCardAmt"], $masterDetails[$z]["godown"], $masterDetails[$z]["del_date"], $masterDetails[$z]["local_app_user_entry_id"], $inv_no, $masterDetails[$z]["SystemId"]);
                        $this->model_mobileapi->getUpdateQueryCollection($billNo, $masterDetails[$z]["BillDate"], $masterDetails[$z]["BillPartyName"], $masterDetails[$z]["BillNetTotalField"], $emp);
                        for ($i = 0; $i < count($data); $i++) {
                            if ($data[$i]["local_app_user_entry_id"] != $masterDetails[$z]["local_app_user_entry_id"]) {
                                continue;
                            } else {
                                $res = $this->model_mobileapi->storeUser($data[$i]["itemname"], $data[$i]["price"], $data[$i]["qty"], $data[$i]["unit"], $data[$i]["party"], $data[$i]["godown"], $data[$i]["employee"], $data[$i]["date1"], $data[$i]["invno"], $data[$i]["local_app_user_entry_id"], $billNo, $data[$i]["serial_no"], $data[$i]["taxAmount"], $data[$i]["taxPercentage"], $data[$i]["itemcode"], $data[$i]["qty_in_pack"], $data[$i]["cost"], $data[$i]["disc"], $data[$i]["sqft"],$data[$i]["taxtype"]);
                                if ($res) {
                                    $b["bill_no"] = $billNo;
                                    $b["id"] = $data[$i]["local_app_user_entry_id"];
                                    $b["status"] = 'uploaded';
                                    $b["previlage"] = '1';
                                    array_push($a, $b);
                                } else {
                                    $b["bill_no"] = $billNo;
                                    $b["id"] = $data[$i]["local_app_user_entry_id"];
                                    $b["status"] = 'pending';
                                    $b["previlage"] = '1';
                                    array_push($a, $b);
                                }
                            }
                        }
                    }
                    echo json_encode($a);
                }
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function deleteCollectionReport(){
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['billNo'])) {
                    $billNo = $_POST['billNo'];
                    $this->model_mobileapi->deleteFromCollectionBySiNo($billNo);
                    $response["success"] = 1;
                    $response["billNo"] = $billNo;
                    $response["message"] = "Collection Bill Deleted";
                    echo json_encode($response);
            }else{
                $response["success"] = 0;
                $response["message"] = "Collection not Deleted";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function deleteSaleBill() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['billNo']) and isset($_POST["empName"])) {
                $inv_no = $_POST['billNo'];
                $emp = $_POST['empName'];
                $billNo = $this->model_mobileapi->getUpdateBillNo($inv_no, $emp);
               // $appuser = $this->model_mobileapi->getUpdatelocal($inv_no, $emp);
                $this->model_mobileapi->deleteFromSalesBillByBillNo($inv_no, $emp);
                $this->model_mobileapi->deleteFromMasterDetailsToSalesBillDelete($inv_no, $emp);
                $this->model_mobileapi->deleteFromCollectionToSaleBillDelete($inv_no);
                $response["success"] = 1;
                $response["billNo"] = $billNo;
                $response["message"] = "Sales Bill Deleted";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function deleteSalesReturn() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['billNo']) and isset($_POST["empName"])) {
                $inv_no = $_POST['billNo'];
                $emp = $_POST['empName'];
               // $appuser = $this->model_mobileapi->getUpdatelocal($inv_no, $emp);
                $this->model_mobileapi->deleteFromSalesReturnByBillNo($inv_no, $emp);
                $this->model_mobileapi->deleteFromSRMasterDetailsDelete($inv_no, $emp);
                $this->model_mobileapi->deleteFromCollectionSalesReturnDelete($inv_no);
                $response["success"] = 1;
              //  $response["billNo"] = $billNo;
                $response["message"] = "Sales Bill Deleted";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong...";
            echo json_encode($response);
        }
    }

    public function deleteIntrans() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['inv_no']) and isset($_POST["party"])) {
                $inv_no = $_POST['inv_no'];
                $emp = $_POST['party'];
                $this->model_mobileapi->deleteFromInTrans($inv_no, $emp);
                $response["success"] = 1;
                $response["inv_no"] = $inv_no;
                $response["message"] = "Intrans Bill Deleted";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function saveReturnInvoice() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['code']) and isset($_POST["salesReturnBillItems"]) and isset($_POST["salesBillSrMasterDetails"])) {
                $salesBillItemsData = $_POST["salesReturnBillItems"];
                $masterDetailsData = $_POST["salesBillSrMasterDetails"];
                $EditModeStatus=$_POST["EditMode"];
                $EditBillNo=$_POST["EditBillNo"];
            //    if (get_magic_quotes_gpc()) {
            //        $salesBillItemsData = stripslashes($salesBillItemsData);
            //        $masterDetailsData = stripslashes($masterDetailsData);
            //    }
                 
                $data = json_decode($salesBillItemsData, true);
                $masterDetails = json_decode($masterDetailsData, true);
                
                // $response["success"] =$masterDetails;
                // $response["message"] = "Required field(s) is missing";
                // echo json_encode($response);
                if ($_POST['code'] == 1) {
                    $previlage = $this->model_mobileapi->getSynPrevilage($_POST['user']);
                    if ($previlage == 1) {
                        $a = array();
                        $b = array();
                        for ($z = 0; $z < count($masterDetails); $z++) {
                            $retNo = $this->model_mobileapi->getSRBillNo();
                            $masterDetails[$z]["RetNo"] = $retNo;
                            if($EditModeStatus=="NO"){                     
                                $this->model_mobileapi->deleteFromSRMasterDetailsByRetNo($masterDetails[$z]["local_app_user_entry_id"], $retNo);
                            }else{
                                $retNo=$EditBillNo;
                            }
                            
                            $this->model_mobileapi->deleteFromCollectionByRetNo($masterDetails[$z]["local_app_user_entry_id"], $retNo);
                            $res = $this->model_mobileapi->storeSalesRetunCollection($retNo, $masterDetails[$z]["BillDate"], $masterDetails[$z]["BillPartyName"], $masterDetails[$z]["BillTotalField"], $masterDetails[$z]["BillNetTotalField"], $masterDetails[$z]["Employee"], $masterDetails[$z]["godown"], $masterDetails[$z]["local_app_user_entry_id"], $masterDetails[$z]["TaxAmt"]);
                            if($EditModeStatus=="YES"){
                                $this->model_mobileapi->getUpdateQuerySRMasterDetails($retNo, $masterDetails[$z]["BillDate"], $masterDetails[$z]["BillPartyName"], $masterDetails[$z]["BillTotalField"], $masterDetails[$z]["BillDiscAmtField"], $masterDetails[$z]["BillDiscPercField"], $masterDetails[$z]["BillTaxField"], $masterDetails[$z]["BillPackageField"], $masterDetails[$z]["BillNetTotalField"], $masterDetails[$z]["BillTyp"], $masterDetails[$z]["TaxAmt"], $masterDetails[$z]["Employee"], $masterDetails[$z]["godown"], $masterDetails[$z]["local_app_user_entry_id"]);
                                $this->db->query("DELETE FROM " . super_model::$table_sales_return . " WHERE  RetNo = '$retNo'");
                            }else{
                              
                                $this->model_mobileapi->getQuery("SRMasterDetails", $masterDetails[$z]);
                            }
                           

                            for ($i = 0; $i < count($data); $i++) {
                                if ($data[$i]["local_app_user_entry_id"] != $masterDetails[$z]["local_app_user_entry_id"]) {
                                    continue;
                                } else {
                                    $res = $this->model_mobileapi->storeSalesRetun($data[$i]["itemname"], $data[$i]["price"], $data[$i]["qty"], $data[$i]["unit"], $data[$i]["party"], $data[$i]["godown"], $data[$i]["employee"], $data[$i]["date1"], $data[$i]["invno"], $data[$i]["local_app_user_entry_id"], $retNo, $data[$i]["serial_no"], $data[$i]["taxAmount"], $data[$i]["taxPercentage"], $data[$i]["itemcode"], $data[$i]["qty_in_pack"], $data[$i]["cost"], $data[$i]["disc"]);
                                    if ($res) {
                                        $b["id"] = $data[$i]["local_app_user_entry_id"];
                                        $b["status"] = 'uploaded';
                                        $b["previlage"] = '1';
                                        array_push($a, $b);
                                    } else {
                                        $b["id"] = $data[$i]["local_app_user_entry_id"];
                                        $b["status"] = 'pending';
                                        $b["previlage"] = '1';
                                        array_push($a, $b);
                                    }
                                }
                            }
                        }
                        $this->model_mobileapi->updateSyncActivationStatus();
                    } else {
                        $a = array();
                        $b = array();
                        $b["bill_no"] = '0';
                        $b["id"] = '0';
                        $b["status"] = 'Update user sync sales return bill Privilage !!';
                        $b["previlage"] = '-1';
                        array_push($a, $b);
                    }
                    echo json_encode($a);
                } else {
                    $a = array();
                    $b = array();
                    for ($z = 0; $z < count($masterDetails); $z++) {
                        $retNo = $this->model_mobileapi->getSRBillNo();
               
                        $retNo =$retNo; 
                        
                        $masterDetails[$z]["RetNo"] =$retNo;
                     
                        if($EditModeStatus=="NO"){
                            $this->model_mobileapi->deleteFromSRMasterDetailsByRetNo($masterDetails[$z]["local_app_user_entry_id"], $retNo);
                        }else{
                            $retNo=$EditBillNo;
                        }
                
                        $this->model_mobileapi->deleteFromCollectionByRetNo($masterDetails[$z]["local_app_user_entry_id"], $retNo);
                        $res = $this->model_mobileapi->storeSalesRetunCollection($retNo, $masterDetails[$z]["BillDate"], $masterDetails[$z]["BillPartyName"], $masterDetails[$z]["BillTotalField"], $masterDetails[$z]["BillNetTotalField"], $masterDetails[$z]["Employee"], $masterDetails[$z]["godown"], $masterDetails[$z]["local_app_user_entry_id"], $masterDetails[$z]["TaxAmt"]);
                        if($EditModeStatus=="YES"){
                            $this->model_mobileapi->getUpdateQuerySRMasterDetails($retNo, $masterDetails[$z]["BillDate"], $masterDetails[$z]["BillPartyName"], $masterDetails[$z]["BillTotalField"], $masterDetails[$z]["BillDiscAmtField"], $masterDetails[$z]["BillDiscPercField"], $masterDetails[$z]["BillTaxField"], $masterDetails[$z]["BillPackageField"], $masterDetails[$z]["BillNetTotalField"], $masterDetails[$z]["BillTyp"], $masterDetails[$z]["TaxAmt"], $masterDetails[$z]["Employee"], $masterDetails[$z]["godown"], $masterDetails[$z]["local_app_user_entry_id"]);
                            $this->db->query("DELETE FROM " . super_model::$table_sales_return . " WHERE  RetNo = '$retNo'");
                        }else{
                            $this->model_mobileapi->getQuery("SRMasterDetails", $masterDetails[$z]);
                        }
                     

                        for ($i = 0; $i < count($data); $i++) {
                            if ($data[$i]["local_app_user_entry_id"] != $masterDetails[$z]["local_app_user_entry_id"]) {
                                continue;
                            } else {
                               
                                $res = $this->model_mobileapi->storeSalesRetun($data[$i]["itemname"], $data[$i]["price"], $data[$i]["qty"], $data[$i]["unit"], $data[$i]["party"], $data[$i]["godown"], $data[$i]["employee"], $data[$i]["date1"], $data[$i]["invno"], $data[$i]["local_app_user_entry_id"], $retNo, $data[$i]["serial_no"], $data[$i]["taxAmount"], $data[$i]["taxPercentage"], $data[$i]["itemcode"], $data[$i]["qty_in_pack"], $data[$i]["cost"], $data[$i]["disc"]);
                                if ($res) {
                                    $b["bill_no"] = $retNo;
                                    $b["id"] = $data[$i]["local_app_user_entry_id"];
                                    $b["status"] = 'uploaded';
                                    $b["previlage"] = '1';
                                    array_push($a, $b);
                                } else {
                                    $b["bill_no"] = $retNo;
                                    $b["id"] = $data[$i]["local_app_user_entry_id"];
                                    $b["status"] = 'pending';
                                    $b["previlage"] = '1';
                                    array_push($a, $b);
                                }
                            }
                        }
                    }
                    echo json_encode($a);
                }
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }
    public function getSino(){
        if ($_SERVER['REQUEST_METHOD'] === 'GET') {
        $res = $this->model_mobileapi->getSiNo();
       if($res == 0){
        $response["success"] = 0;
        $response["message"] = "Required field(s) is missing";
        echo json_encode($response);
       }else{
       $response["SiNO"] = $res;
       $response["message"] = "Success!";
       echo json_encode($response);
            }
    }
    }
    public function getCashparty(){
        if ($_SERVER['REQUEST_METHOD'] === 'GET') {
            $res = $this->model_mobileapi->getCashParty();
           if($res == 0){
            $response["failed"] = 0;
            $response["message"] = "Required field(s) is missing";
            echo json_encode($response);
           }else{
           $response["party"] = $res;
           $response["message"] = "Success!";
           echo json_encode($response);
                }
        }
    }
    

    public function saveReceipt() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['code']) and isset($_POST["usersJSON"])) {
            //    if (get_magic_quotes_gpc()) {
            //        $json = stripslashes($json);
            //    }                
                $data = json_decode($_POST["usersJSON"]);
                $a = array();
                $b = array();
//                $SiNo = $this->model_mobileapi->getSiNo();
                if ($_POST['code'] == 1) {
                    $previlage = $this->model_mobileapi->getSynPrevilage($_POST['user']);
                    if ($previlage == 1) {
                        for ($i = 0; $i < count($data); $i++) {
                            $SiNo = $this->model_mobileapi->getSiNo();
                            $res = $this->model_mobileapi->storeDebit(strtoupper($data[$i]->party), $data[$i]->amount, $data[$i]->date1, $data[$i]->user, $data[$i]->godown, $data[$i]->image_data, $data[$i]->transaction_type, $data[$i]->cheque_no, $data[$i]->narration, $data[$i]->local_app_user_entry_id, $SiNo);
                            if ($res) {
                                $b["id"] = $data[$i]->id;
                                $b["status"] = 'uploaded';
                                $b["previlage"] = '1';
                                array_push($a, $b);
                            } else {
                                $b["id"] = $data[$i]->id;
                                $b["status"] = 'pending';
                                $b["previlage"] = '1';
                                array_push($a, $b);
                            }
                        }
                        $this->model_mobileapi->updateSyncActivationStatus();
                    } else {
                        $b["id"] = "0";
                        $b["status"] = 'Update user sync save receipt Privilage !!';
                        $b["previlage"] = '-1';
                        array_push($a, $b);
                    }
                    echo json_encode($a);
                } else {
                    for ($i = 0; $i < count($data); $i++) {
                        $SiNo = $this->model_mobileapi->getSiNo();
                        $res = $this->model_mobileapi->storeDebit(strtoupper($data[$i]->party), $data[$i]->amount, $data[$i]->date1, $data[$i]->user, $data[$i]->godown, $data[$i]->image_data, $data[$i]->transaction_type, $data[$i]->cheque_no, $data[$i]->narration, $data[$i]->local_app_user_entry_id, $SiNo);
                        if ($res) {
                            $b["id"] = $data[$i]->id;
                            $b["status"] = 'uploaded';
                            $b["previlage"] = '1';
                            array_push($a, $b);
                        } else {
                            $b["id"] = $data[$i]->id;
                            $b["status"] = 'pending';
                            $b["previlage"] = '1';
                            array_push($a, $b);
                        }
                    }
                    echo json_encode($a);
                }
            }
        }
    }

    public function updateReceipt() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST['SiNo']) and isset($_POST["usersJSON"])) {
            //    if (get_magic_quotes_gpc()) {
            //        $json = stripslashes($json);
            //    }                
                $data = json_decode($_POST["usersJSON"]);
                $SiNo = json_decode($_POST["SiNo"]);
                $a = array();
                $b = array();
//                $SiNo = $this->model_mobileapi->getSiNo();
                        for ($i = 0; $i < count($data); $i++) {
                            $res = $this->model_mobileapi->storeDebit(strtoupper($data[$i]->party), $data[$i]->amount, $data[$i]->date1, $data[$i]->user, $data[$i]->godown, $data[$i]->image_data, $data[$i]->transaction_type, $data[$i]->cheque_no, $data[$i]->narration, $data[$i]->local_app_user_entry_id, $SiNo);
                            if ($res) {
                                $b["id"] = $SiNo;
                                $b["status"] = 'uploaded';
                                array_push($a, $b);
                            } else {
                                $b["id"] = $SiNo;
                                $b["status"] = 'pending';
                                array_push($a, $b);
                            }
                            echo json_encode($a);
                        }
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function saveGPSData() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["usersJSON"])) {
                $json = $_POST["usersJSON"];
            //    if (get_magic_quotes_gpc()) {
            //        $json = stripslashes($json);
            //    }

                $data = json_decode($json);
                $a = array();
                $b = array();
                for ($i = 0; $i < count($data); $i++) {
                    $res = $this->model_mobileapi->storeGPS($data[$i]->latitude, $data[$i]->longitude, $data[$i]->party_name, $data[$i]->action, $data[$i]->date1, $data[$i]->user, $data[$i]->godown);
                    if ($res) {
                        $b["id"] = $data[$i]->id;
                        $b["status"] = 'UPLOADED';
                        array_push($a, $b);
                    } else {
                        $b["id"] = $data[$i]->id;
                        $b["status"] = 'PENDING';
                        array_push($a, $b);
                    }
                }
                echo json_encode($a);
            }
        }
    }

    public function saveOrder() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["orderBillItems"]) and isset($_POST["orderBillMasterDetails"])) {
                $orderBillItemsData = $_POST["orderBillItems"];
                $ordermasterDetailsData = $_POST["orderBillMasterDetails"];
            //    if (get_magic_quotes_gpc()) {
            //        $orderBillItemsData = stripslashes($orderBillItemsData);
            //        $ordermasterDetailsData = stripslashes($ordermasterDetailsData);
            //    }
             
                
                $data = json_decode($orderBillItemsData, true);
                $masterDetails = json_decode($ordermasterDetailsData, true);
                $a = array();
                $b = array();
                for ($z = 0; $z < count($masterDetails); $z++) {
                    $billNo = $this->model_mobileapi->getOrderBillNo();
                    $masterDetails[$z]["BillNo"] = $billNo;
                    $this->model_mobileapi->deleteFromMasterDetails8BByBillNo($masterDetails[$z]["local_app_user_entry_id"], $billNo);
                    $this->model_mobileapi->getQuery("MasterDetails8B", $masterDetails[$z]);
                    for ($i = 0; $i < count($data); $i++) {
                        if ($data[$i]["local_app_user_entry_id"] != $masterDetails[$z]["local_app_user_entry_id"]) {
                            continue;
                        } else {
                            $res = $this->model_mobileapi->storeOrderUser($data[$i]["itemname"], $data[$i]["price"], $data[$i]["qty"], $data[$i]["unit"], $data[$i]["party"], $data[$i]["godown"], $data[$i]["employee"], $data[$i]["date1"], $data[$i]["invno"], $data[$i]["local_app_user_entry_id"], $billNo, $data[$i]["serial_no"], $data[$i]["taxAmount"], $data[$i]["taxPercentage"], $data[$i]["itemcode"], $data[$i]["qty_in_pack"]);
                            if ($res) {
                                $b["bill_no"] = $billNo;
                                $b["id"] = $data[$i]["local_app_user_entry_id"];
                                $b["status"] = 'uploaded';
                                array_push($a, $b);
                            } else {
                                $b["bill_no"] = $billNo;
                                $b["id"] = $data[$i]["local_app_user_entry_id"];
                                $b["status"] = 'pending';
                                array_push($a, $b);
                            }
                        }
                    }
                }
                echo json_encode($a);
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function saveParty() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["SaveParty"])) {
                $savePartyItems = $_POST["SaveParty"];
                $data = json_decode($savePartyItems, true);
                $a = array();
                $b = array();
                for ($i = 0; $i < count($data); $i++) {
                    $name = $data[$i]["name"];
                    $code = $data[$i]["code"];
                    $address1 = $data[$i]["address1"];
                    $address2 = $data[$i]["address2"];
                    $mobNo = $data[$i]["mobileno"];
                    $gstNumber = $data[$i]["gst_no"];
                    $stateAndCode = $data[$i]["cst_no"];
                    // $balance = $data[$i]["balance"];  
                    $balance = $data[$i]["opening"];  
                    $local_app_user_entry_id = $data[$i]["local_app_user_entry_id"];
                    $partyType = $data[$i]["party_type"];
                    $user = $data[$i]["user_name"];
                    date_default_timezone_set('Asia/Kolkata');
                    $dateTime = date('Y-m-d 00:00:00', time());
                    $res = $this->model_mobileapi->addNewParty(strtoupper($name), strtoupper($code), strtoupper($address1), strtoupper($address2), $mobNo, strtoupper($gstNumber), strtoupper($stateAndCode), $balance, strtoupper($user), $dateTime, $local_app_user_entry_id, strtoupper($partyType));
         
                    if ($res) {
                        $b["id"] = $data[$i]["local_app_user_entry_id"];
                        $b["status"] = 'uploaded';
                        array_push($a, $b);
                    } else {
                        $b["id"] = $data[$i]["local_app_user_entry_id"];
                        $b["status"] = 'pending';
                        array_push($a, $b);
                    }

                }
                echo json_encode($a);
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function savePayment() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["usersJSON"])) {
            //    if (get_magic_quotes_gpc()) {
            //        $json = stripslashes($json);
            //    }
                
                $data = json_decode($_POST["usersJSON"]);
                $a = array();
                $b = array();
//                $SiNo = $this->model_mobileapi->getSiNo();
                for ($i = 0; $i < count($data); $i++) {
                    $SiNo = $this->model_mobileapi->getSiNo();
                    $res = $this->model_mobileapi->storeCredit(strtoupper($data[$i]->party), $data[$i]->amount, $data[$i]->date1, $data[$i]->user, $data[$i]->godown, $data[$i]->transaction_type, $data[$i]->cheque_no, $data[$i]->narration, $data[$i]->local_app_user_entry_id, $SiNo);

                    if ($res) {
                        $b["id"] = $data[$i]->id;
                        $b["status"] = 'uploaded';
                        array_push($a, $b);
                    } else {
                        $b["id"] = $data[$i]->id;
                        $b["status"] = 'pending';
                        array_push($a, $b);
                    }
                }
                echo json_encode($a);
            }
        }
    }

    public function saveExpense() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["usersJSON"])) {
            //    if (get_magic_quotes_gpc()) {
            //        $json = stripslashes($json);
            //    }                
                $data = json_decode($_POST["usersJSON"]);
                $a = array();
                $b = array();
//                $SiNo = $this->model_mobileapi->getSiNo();
                for ($i = 0; $i < count($data); $i++) {
                    $SiNo = $this->model_mobileapi->getSiNo();
                    $res = $this->model_mobileapi->storeExpense(strtoupper($data[$i]->party), $data[$i]->amount, $data[$i]->date1, $data[$i]->user, $data[$i]->godown, $data[$i]->transaction_type, $data[$i]->cheque_no, $data[$i]->narration, $data[$i]->local_app_user_entry_id, $SiNo);

                    if ($res) {
                        $b["id"] = $data[$i]->id;
                        $b["status"] = 'uploaded';
                        array_push($a, $b);
                    } else {
                        $b["id"] = $data[$i]->id;
                        $b["status"] = 'pending';
                        array_push($a, $b);
                    }
                }
                echo json_encode($a);
            }
        }
    }

    public function saveTakeStockToPBill() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["usersJSON"])) {
            //    if (get_magic_quotes_gpc()) {
            //        $json = stripslashes($json);
            //    }                
                $data = json_decode($_POST["usersJSON"]);
                $a = array();
                $b = array();
            //    $BillNo1 = $this->model_mobileapi->getInvNo();
                for ($i = 0; $i < count($data); $i++) {
                    $BillNo1 = $this->model_mobileapi->getInvNo();
                    $res1 = $this->model_mobileapi->storeTakeStockToPBill($BillNo1,$data[$i]->party,$data[$i]->netTotal,$data[$i]->billTime,$data[$i]->invDate,$data[$i]->totalQuantity,$data[$i]->local_app_user_entry_id,$data[$i]->employee,$data[$i]->PNetV,$data[$i]->PTaxA) ;
                    if ($res1) {
                        // $b["id"] = $data[$i]->id;
                        $b["status"] = 'uploaded';
                        $b["BillNo"] = $BillNo1;
                        array_push($a, $b);
                    } else {
                        // $b["id"] = $data[$i]->id;
                        $b["status"] = 'pending';
                        $b["BillNo"] = $BillNo1;
                        array_push($a, $b);
                    }
                }
                echo json_encode($a);
            }else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
                return;
            }

        }else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
            return;
        }
    }
    

    public function saveTakeStock() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["usersJSON"])) {
            //    if (get_magic_quotes_gpc()) {
            //        $json = stripslashes($json);
            //    }                
                $data = json_decode($_POST["usersJSON"]);
                $TakeStockBillNo=$_POST["TakeStockBillNo"];
                $a = array();
                $b = array();
            //    $BillNo2 = $this->model_mobileapi->getInvNo();
                for ($i = 0; $i < count($data); $i++) {
                    // $BillNo = $this->model_mobileapi->getInvNo();
                    $res = $this->model_mobileapi->storeTakeStock($data[$i]->id,$data[$i]->itemname, $data[$i]->price,$data[$i]->qty,$data[$i]->unit,$data[$i]->itemcode,$data[$i]->pack,$data[$i]->cost,$data[$i]->MRP,$data[$i]->total,$data[$i]->PBDate,$data[$i]->EXDate,$data[$i]->local_app_user_entry_id,$data[$i]->employee,$data[$i]->PTaxP,$data[$i]->PTaxA,$data[$i]->PNetV,$i,$data[$i]->arabicname,$TakeStockBillNo);
                    if ($res) {
                        // $b["id"] = $data[$i]->id;
                        $b["status"] = 'uploaded';
                        array_push($a, $b);
                    } else {
                        // $b["id"] = $data[$i]->id;
                        $b["status"] = 'pending';
                        array_push($a, $b);
                    }
                }
                echo json_encode($a);
            }else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
                return;
            }

        }else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
            return;
        }
    }

    public function saveTakeStockToCollection() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["usersJSON"])) {
            //    if (get_magic_quotes_gpc()) {
            //        $json = stripslashes($json);
            //    }                
                $data = json_decode($_POST["usersJSON"]);
                $a = array();
                $b = array();
            //    $BillNo3 = $this->model_mobileapi->getInvNo();
            //    $BillNo3 += 1;
                for ($i = 0; $i < count($data); $i++) {
                    $res1 = $this->model_mobileapi->saveTakeStockToCollection($data[$i]->date1,$data[$i]->party,$data[$i]->netTotal,$data[$i]->employee,$data[$i]->local_app_user_entry_id,$data[$i]->billTime) ;
                    if ($res1) {
                        // $b["id"] = $data[$i]->id;
                        $b["status"] = 'uploaded';
                        array_push($a, $b);
                    } else {
                        // $b["id"] = $data[$i]->id;
                        $b["status"] = 'pending';
                        array_push($a, $b);
                    }
                }
                echo json_encode($a);
            }else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
                return;
            }

        }else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
            return;
        }
    }
    

    public function saveProduct() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["productJSON"])) {
            //    if (get_magic_quotes_gpc()) {
            //        $json = stripslashes($json);
            //    }
              
                
                $data = json_decode($_POST["productJSON"]);
                $a = array();
                $b = array();
                for ($i = 0; $i < count($data); $i++) {
                    $res = $this->model_mobileapi->storeProduct(strtoupper($data[$i]->itemname), $data[$i]->itemcode, $data[$i]->stock, $data[$i]->user, $data[$i]->godown, $data[$i]->base_rate_retail, $data[$i]->sec_rate_retail, $data[$i]->base_unit, $data[$i]->sec_unit, $data[$i]->category, $data[$i]->img, $data[$i]->tax, $data[$i]->base_rate_wholesale, $data[$i]->sec_rate_wholesale, $data[$i]->qty_in_pack, $data[$i]->local_app_user_entry_id, $data[$i]->Cost, $data[$i]->SecCostRate, $data[$i]->StockInMain, $data[$i]->Rate3, $data[$i]->prod_typ, $data[$i]->CostRs, $data[$i]->Disc, $data[$i]->DiscP, $data[$i]->Color,$data[$i]->ArabicName,$data[$i]->ThirdCost,$data[$i]->ThirdFirstRate,$data[$i]->ThirdUnit,$data[$i]->ThirdPack);
//                    print_r($res);
                    if ($res) {
                        $b["statusid"] = 1;
                        $b["id"] = $data[$i]->id;
                        $b["status"] = 'uploaded';
                        array_push($a, $b);
                    } else {
                        $b["statusid"] = 0;
                        $b["id"] = $data[$i]->id;
                        $b["status"] = 'pending';
                        array_push($a, $b);
                    }
                }
                echo json_encode($a);
            }
        }
    }


    public function saveDamage() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["DamageData"])) {
            //    if (get_magic_quotes_gpc()) {
            //        $json = stripslashes($json);
            //    }
              $d = $_POST["DamageData"];
                
              $data = json_decode($d, true);
                $billno = $this->model_mobileapi->getInvNodamage();
                $a = array();
                $b = array();
                for ($i = 0; $i < count($data); $i++) {
                    //print_r($data[0]["itemname"]);
                    $res = $this->model_mobileapi->storeDamage($data,$billno);
//                    print_r($res);
                    if ($res) {
                        $b["statusid"] = 1;
                       // $b["id"] = $data[0]->id;
                        $b["status"] = 'uploaded';
                        array_push($a, $b);
                    } else {
                        $b["statusid"] = 0;
                      //  $b["id"] = $data[0]->id;
                        $b["status"] = 'pending';
                        array_push($a, $b);
                    }
                }
                echo json_encode($a);
            }
        }
    }


    public function savePurchase() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["purchaseBillItems"]) and isset($_POST["pbillMasterDetails"])) {
                $salesBillItemsData = $_POST["purchaseBillItems"];
                $masterDetailsData = $_POST["pbillMasterDetails"];
                $collectionData = $_POST["purchasecollection"];
            //    if (get_magic_quotes_gpc()) {
            //        $salesBillItemsData = stripslashes($salesBillItemsData);
            //        $masterDetailsData = stripslashes($masterDetailsData);
            //    }
                
              
                
                $data = json_decode($salesBillItemsData, true);
                $masterDetails = json_decode($masterDetailsData, true);
                $collection = json_decode($collectionData, true);
                $a = array();
                $b = array();
                for ($z = 0; $z < count($masterDetails); $z++) {
                    $invoNo = $this->model_mobileapi->getPurchaseInvNo();
                    $masterDetails[$z]["InvoiceNo"] = $invoNo;
                    $this->model_mobileapi->deleteFromPBillByInvoNo($masterDetails[$z]["local_app_user_entry_id"], $invoNo);
                    $this->model_mobileapi->getQuery("PBill", $masterDetails[$z]);
                    for ($i = 0; $i < count($data); $i++) {
                        if ($data[$i]["local_app_user_entry_id"] != $masterDetails[$z]["local_app_user_entry_id"]) {
                            continue;
                        } else {
                            $res = $this->model_mobileapi->storePurchaseBill($data[$i]["itemname"], $data[$i]["price"], $data[$i]["qty"], $data[$i]["unit"], $data[$i]["party"], $data[$i]["godown"], $data[$i]["employee"], $data[$i]["date1"], $data[$i]["invno"], $data[$i]["local_app_user_entry_id"], $invoNo, $data[$i]["serial_no"], $data[$i]["taxAmount"], $data[$i]["taxPercentage"], $data[$i]["itemcode"], $data[$i]["qty_in_pack"]);
                            if ($res) {
                                $b["bill_no"] = $invoNo;
                                $b["id"] = $data[$i]["local_app_user_entry_id"];
                                $b["status"] = 'uploaded';
                                array_push($a, $b);
                            } else {
                                $b["bill_no"] = $invoNo;
                                $b["id"] = $data[$i]["local_app_user_entry_id"];
                                $b["status"] = 'pending';
                                array_push($a, $b);
                            }
                        }
                    }
                    $this->model_mobileapi->StorePurchaseCollection($invoNo, $collection[$z]["Date1"], $collection[$z]["PartyName"], $collection[$z]["Amount"], $collection[$z]["godown"], $collection[$z]["local_app_user_entry_id"], $collection[$z]["bill_time"]);
                }
                echo json_encode($a);
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
                return;
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
            return;
        }
    }




    public function syncTakeStock() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["purchaseBillItems"]) && isset($_POST["pbillMasterDetails"])) {



                $salesBillItemsData = $_POST["purchaseBillItems"];
                $masterDetailsData = $_POST["pbillMasterDetails"];
                $collectionData = $_POST["purchasecollection"];


               // $masterDetailsData = $_POST["pbillMasterDetails"];
              //  $masterDetailsData = json_decode($_POST["pbillMasterDetails"]);


               // print_r($masterDetailsData);
               // $collectionData = $_POST["purchasecollection"];
            //    if (get_magic_quotes_gpc()) {
            //        $salesBillItemsData = stripslashes($salesBillItemsData);
            //        $masterDetailsData = stripslashes($masterDetailsData);
            //    }
                
              
           // print_r('here 1.1');
                $data = json_decode($salesBillItemsData,true);
        
                $masterDetails = json_decode($masterDetailsData,true);

              
                $collection = json_decode($collectionData, true);
                $a = array();
                $b = array();
                
                for ($z = 0; $z < count($masterDetails); $z++) {
                   // print_r('here 3');
                    $invoNo = $this->model_mobileapi->getPurchaseInvNo();
                    //$masterDetails[$z]["InvoiceNo"] = $invoNo;
                    $this->model_mobileapi->storeTakeStockToPBill($invoNo,$masterDetails[$z]["party"],$masterDetails[$z]["netTotal"],$masterDetails[$z]["billTime"],$masterDetails[$z]["invDate"],$masterDetails[$z]["totalQuantity"],$masterDetails[$z]["local_app_user_entry_id"],$masterDetails[$z]["employee"],$masterDetails[$z]["PNetV"],$masterDetails[$z]["PTaxA"]) ;
                    // $this->model_mobileapi->storeTakeStockToPBill($invoNo,$masterDetails[$z]->party,$masterDetails[$z]->netTotal,$masterDetails[$z]->billTime,$masterDetails[$z]->invDate,$masterDetails[$z]->totalQuantity,$masterDetails[$z]->local_app_user_entry_id,$masterDetails[$z]->employee,$masterDetails[$z]->PNetV) ;
                    //$this->model_mobileapi->deleteFromPBillByInvoNo($masterDetails[$z]["local_app_user_entry_id"], $invoNo);
                  //  $this->model_mobileapi->getQuery("PBill", $masterDetails[$z]);
                    for ($i = 0; $i < count($data); $i++) {
                        if ($data[$i]["inv_no"] != $masterDetails[$z]["inv_no"]) {
                            continue;
                        } else {
                            $res = $this->model_mobileapi->SyncTakeStockPurchaseBill($data[$i]["id"],$data[$i]["itemname"], $data[$i]["price"],$data[$i]["qty"],$data[$i]["unit"],$data[$i]["itemcode"],$data[$i]["pack"],$data[$i]["cost"],$data[$i]["MRP"],$data[$i]["total"],$data[$i]["PBDate"],$data[$i]["EXDate"],$data[$i]["local_app_user_entry_id"],$data[$i]["employee"],$data[$i]["PTaxP"],$data[$i]["PTaxA"],$data[$i]["PNetV"],$i,$data[$i]["arabicname"],$invoNo);
                           // $res1 = $this->model_mobileapi->storeTakeStockToPBill($BillNo1,$data[$i]->party,$data[$i]->netTotal,$data[$i]->billTime,$data[$i]->invDate,$data[$i]->totalQuantity,$data[$i]->local_app_user_entry_id,$data[$i]->employee,$data[$i]->PNetV) ;
                           // $res = $this->model_mobileapi->storePurchaseBill($data[$i]["itemname"], $data[$i]["price"], $data[$i]["qty"], $data[$i]["unit"], $data[$i]["party"], $data[$i]["godown"], $data[$i]["employee"], $data[$i]["date1"], $data[$i]["invno"], $data[$i]["local_app_user_entry_id"], $invoNo, $data[$i]["serial_no"], $data[$i]["taxAmount"], $data[$i]["taxPercentage"], $data[$i]["itemcode"], $data[$i]["qty_in_pack"]);
                            if ($res) {
                                $b["bill_no"] = $invoNo;
                                $b["id"] = $data[$i]["local_app_user_entry_id"];
                                $b["status"] = 'uploaded';
                                array_push($a, $b);
                            } else {
                                $b["bill_no"] = $invoNo;
                                $b["id"] = $data[$i]["local_app_user_entry_id"];
                                $b["status"] = 'pending';
                                array_push($a, $b);
                            }
                        }
                    }
                    $this->model_mobileapi->StorePurchaseCollection($invoNo, $collection[$z]["date1"], $collection[$z]["party"], $collection[$z]["netTotal"], $collection[$z]["employee"], $collection[$z]["local_app_user_entry_id"], $collection[$z]["billTime"]);
                }
                echo json_encode($a);
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
                return;
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
            return;
        }
    }




    public function manageParty() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["methodType"])) {
                $methodType = $_POST["methodType"];
                if ($methodType === "listParty") {
                    $data["response"] = array();
                    $data["success"] = 1;
                    $data["response"] = $this->model_mobileapi->listParty();
                    echo json_encode($data);
                } else if ($methodType === "addNewParty") {
                    $name = $_POST['name'];
                    $code = $_POST['code'];
                    $address1 = $_POST['address1'];
                    $address2 = $_POST['address2'];
                    $mobNo = $_POST['mob'];
                    $gstNumber = $_POST['gstNumber'];
                    $stateAndCode = $_POST['stateAndCode'];
                    $balance = $_POST['balance'];
                    $user = $_POST['user'];
                    date_default_timezone_set('Asia/Kolkata');
                    $dateTime = date('Y-m-d 00:00:00', time());
                    $qry = $this->model_mobileapi->addNewParty(strtoupper($name), strtoupper($code), strtoupper($address1), strtoupper($address2), $mobNo, strtoupper($gstNumber), strtoupper($stateAndCode), $balance, strtoupper($user), $dateTime);
                    if ($qry) {
                        $data["success"] = 1;
                        echo json_encode($data);
                    } else {
                        $data["success"] = 0;
                        echo json_encode($data);
                    }
                } else if ($methodType === "editParty") {
                    $name = $_POST['name'];
                    $code = $_POST['code'];
                    $address1 = $_POST['address1'];
                    $address2 = $_POST['address2'];
                    $mobNo = $_POST['mob'];
                    $gstNumber = $_POST['gstNumber'];
                    $stateAndCode = $_POST['stateAndCode'];
                    $balance = $_POST['balance'];
                    $user = $_POST['user'];
                    date_default_timezone_set('Asia/Kolkata');
                    $dateTime = date('Y-m-d 00:00:00', time());
                    $this->model_mobileapi->deleteFromMaster('CUSTOMER', $name);
                    $this->model_mobileapi->deleteFromCollection('Opening', 'CUSTOMER', $name);
                    $qry = $this->model_mobileapi->addNewParty($name, $code, $address1, $address2, $mobNo, $gstNumber, $stateAndCode, $balance, $user, $dateTime);
                    if ($qry) {
                        $data["success"] = 1;
                        echo json_encode($data);
                    } else {
                        $data["success"] = 0;
                        echo json_encode($data);
                    }
                    $data["success"] = 1;
                    echo json_encode($data);
                } else if ($methodType === "getParty") {
                    $data["success"] = 1;
                    $data["products"] = $this->model_mobileapi->getPartyByName($_POST['partyName']);
                    echo json_encode($data);
                }
            }
        }
    }

     public function sendSMS() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["code"]) and isset($_POST["number"]) and isset($_POST["msg"])) {
                $number = $_POST['number'];
                $msg = $_POST['msg'];
                $username = "kckdental"; //use your sms api username
                $pass = "ysdAP9H5";  //enter your password
                $dest_mobileno = $number; //reciever 10 digit number (use comma (,) for multiple users. eg: 9999999999,8888888888,7777777777)
                $message = urlencode($msg); //sms content
                $senderid = "KCKSER"; //use your sms api sender id
                $url = "http://sms.rbsindia.net/api/sms?format=xml&key=cea762587be943f323fde2988919e1f1&method=MT&mobile=" . $number . "&sender=KAMBRN&route=TL&text=" . $message;
                file_get_contents($url);
                $response["success"] = 1;
                $response["message"] = "mseeg : " . $msg . "  nummmmmm  " . $number;
                echo json_encode($response);
            } else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function UpdatePriceChart() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["price1"]) and isset($_POST["price2"]) and isset($_POST["price3"])) {
                $price1 = $_POST["price1"];
                $price2 = $_POST["price2"];
                $price3 = $_POST["price3"];
                $res1 = $this->model_mobileapi->priceChart($price1,$price2,$price3) ;
                $response["success"] = 1;
                $response["message"] = "Succesfully Uploaded";
                echo json_encode($response);
            }else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
                return;
            }

        }else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
            return;
        }
    }

    public function saveIntransaction() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["salesIntransItems"])) {
                $json = $_POST["salesIntransItems"];
                echo ($json);
            //    if (get_magic_quotes_gpc()) {
            //        $json = stripslashes($json);
            //    }
                $data = json_decode($json);
                $a = array();
                $b = array();
                if ($_POST['code'] == 1) {
                for ($i = 0; $i < count($data); $i++) {
                    $res = $this->model_mobileapi->saveintrans($data[$i]->itemname, $data[$i]->qty, $data[$i]->rate, $data[$i]->total, $data[$i]->party, $data[$i]->net_qty,$data[$i]->net_amnt,$data[$i]->godown, $data[$i]->employee, $data[$i]->date1, $data[$i]->inv_no, $data[$i]->local_app_user_entry_id,$data[$i]->credit,$data[$i]->inv_no_str,$data[$i]->type);
                        $b["id"] = $data[$i]->local_app_user_entry_id;
                        $b["status"] = 'uploaded';
                        array_push($a, $b);
                }
                echo json_encode($a);
            }
            }else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function saveIntransactionOne() {
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
            if (isset($_POST["salesIntransItems"]) and isset($_POST["intranscount"])) {
                $json = $_POST["salesIntransItems"];
                $json1 = $_POST["intranscount"];
            //    if (get_magic_quotes_gpc()) {
            //        $json = stripslashes($json);
            //        $json1 = stripslashes($json1);
            //    }
                $data2 = json_decode($json,true);
                $data = json_decode($json);
                $data1 = json_decode($json1,true);
                // echo json_encode($data1);
                $a = array();
                $b = array();
                for( $z = 0; $z < count($data1) ; $z++){
                $BillNo = $this->model_mobileapi->getInvNoIntrans();
                if ($_POST['code'] == 1) {
                for ($i = 0; $i < count($data); $i++) {
                    if ( $data2[$i]["inv_no"] != $data1[$z]["inv_no"]) {
                        continue;
                    } else {
                    $res = $this->model_mobileapi->saveintrans($data[$i]->itemname, $data[$i]->qty, $data[$i]->rate, $data[$i]->total, $data[$i]->party, $data[$i]->net_qty,$data[$i]->net_amnt,$data[$i]->godown, $data[$i]->employee, $data[$i]->date1, $BillNo, $data[$i]->local_app_user_entry_id,$data[$i]->credit,$data[$i]->inv_no_str,$data[$i]->type);
                        $b["id"] = $data[$i]->local_app_user_entry_id;
                        $b["party"] = $data[$i]->party;
                        $b["status"] = 'uploaded';
                        array_push($a, $b);
                }
            }
                echo json_encode($a);
            }
            }
            }else {
                $response["success"] = 0;
                $response["message"] = "Required field(s) is missing";
                echo json_encode($response);
            }
        } else {
            $response["success"] = 0;
            $response["message"] = "Something went wrong";
            echo json_encode($response);
        }
    }

    public function getPrices(){
        if ($_SERVER['REQUEST_METHOD'] === 'POST') {
        $res = $this->model_mobileapi->getPriceOneToFiftynine();
        $res1 = $this->model_mobileapi->getPriceFiftyToSevenFour();
        $res2 = $this->model_mobileapi->getPriceSevenficeAbove();
        $a = array();
        $b = array();
        // getPriceChartPrices
        if ($res) {
            $b["desc1"] = $res;
            $b["desc2"] = $res1;
            $b["desc3"] = $res2;
            $b["previlage"] = '1';
            array_push($a, $b);
        } else {
            $b["success"] = 0;
            $b["message"] = "Required field(s) is missing";
            array_push($a, $b);
        }
        echo json_encode($a);
      
    } else {
        $response["success"] = 0;
        $response["message"] = "Something went wrong";
        echo json_encode($response);
    }
    }

}